#procedure keepUVloops()

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** Procedure to keep only integrals actually UV divergent.
** Begun on 16/09/02

.sort
set UV: a0,b0,b1,b00,b11,c00,c001,c002,d0000;

* I assume ArgumentsB to exist at this point...
hide ArgumentsA;
hide ArgumentsB;

if ( match(a0?UV) = 0 ) discard;  

.sort
unhide;

#endprocedure
*$Id: keepUVloops.prc,v 1.3 2004/10/08 14:28:11 alorca Exp $
