#procedure onshell()

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** To substitute the external momenta for external particle masses
** and Mandelstan variables
** Begun on 05/02/03

** Of course depending on the legs, the procedure is quite different

#if `LEGS' == 5

*** NOT CORRECT YET
#do i1=1,{`LEGS'-1}
 #do i2={`i1'+1},5
  id p`i1'.p`i2'=1/2*(p`i1'`i2'man-p`i1'.p`i1'-p`i2'.p`i2');
 #enddo
#enddo

id p1.p1=`emm1';
id p2.p2=`emm3';
id p3.p3=`emm4';
id p4.p4=`emm5';
id p5.p5=`emm2';

argument;
#do i1=1,{`LEGS'-1}
 #do i2={`i1'+1},5
  id p`i1'.p`i2'=1/2*(p`i1'`i2'man-p`i1'.p`i1'-p`i2'.p`i2');
 #enddo
#enddo

id p1.p1=`emm1';
id p2.p2=`emm3';
id p3.p3=`emm4';
id p4.p4=`emm5';
id p5.p5=`emm2';

endargument;

#elseif `LEGS' == 4
** Let's give the external mass offered by Diana, (2-3 are interchanged)
** First including Mandelstan variables

id p1.p2=1/2*(tman-p1.p1-p2.p2);
id p1.p3=1/2*(uman-p1.p1-p3.p3);
id p1.p4=1/2*(sman-p1.p1-p4.p4);
id p2.p3=1/2*(sman-p2.p2-p3.p3);
id p2.p4=1/2*(uman-p2.p2-p4.p4);
id p3.p4=1/2*(tman-p3.p3-p4.p4);

id p1.p1=`emm1';
id p2.p2=`emm3';
id p3.p3=`emm4';
id p4.p4=`emm2';

argument;
id p1.p2=1/2*(tman-p1.p1-p2.p2);
id p1.p3=1/2*(uman-p1.p1-p3.p3);
id p1.p4=1/2*(sman-p1.p1-p4.p4);
id p2.p3=1/2*(sman-p2.p2-p3.p3);
id p2.p4=1/2*(uman-p2.p2-p4.p4);
id p3.p4=1/2*(tman-p3.p3-p4.p4);

id p1.p1=`emm1';
id p2.p2=`emm3';
id p3.p3=`emm4';
id p4.p4=`emm2';
endargument;

** At some point, the funniest composition s+t+u=mm1+mm2+mm3+mm4 may appear...
** We use `CHANNEL', `LOOPTYPE' and `SKELETON' to specify our substitutions.
** By default, we will substitute 'uman' by 'sman' and 'tman', only if u symmetry appears
** we will move 'tman' by 'sman' and 'uman'. Boxes play an independent footing.

#define a "uman"

#if     `LEVEL'fcn == "S"
#elseif `LEVEL'fcn == "T"
#elseif `LEVEL'fcn == "U"
  #redefine a "tman"
#elseif `LEVEL'fcn == "S,T"
#elseif `LEVEL'fcn == "S,U"
  #redefine a "tman"
#elseif `LEVEL'fcn == "T,U"
  #redefine a "sman"
#elseif `LEVEL'fcn == "S,T,U"
#endif

id `a'=-(sman+tman+uman-`a')+`emm1'+`emm2'+`emm3'+`emm4';

#if `TOPOLOGY' == 4x3d
* We have crossed TU box
  #redefine a "sman"
#elseif `TOPOLOGY' == 4x2d
* We have crossed SU box
  #redefine a "tman"
#elseif `TOPOLOGY' == 4x1d
  #redefine a "uman"
#endif

argument;
  id `a'=-(sman+tman+uman-`a')+`emm1'+`emm2'+`emm3'+`emm4';
endargument;


#elseif `LEGS' == 3
 #message [onshell: not yet 3 legs available]
 .end
#elseif `LEGS' == 2

id p2=-p1;
*id p1.p2=1/2*(tman-p1.p1-p2.p2);
id p1.p1=sman;
*id p2.p2=`emm2';
argument;
  id p2=-p1;
*  id p1.p2=1/2*(tman-p1.p1-p2.p2);
  id p1.p1=sman;
*  id p2.p2=`emm2';
endargument;
 #if `EXTFERMICURRENTS' == 0
  #call transvorlongit(sman)
 #endif

#endif

#call massconvention()

#endprocedure
*$Id: onshell.prc,v 1.9 2004/10/29 13:07:26 alorca Exp $
